// main chunk of front-end
// $Id: m4mailconf.cc,v 1.1 2000/02/04 19:48:12 waider Exp $
#pragma implementation
#include "m4mailconf.h"
#include "internal.h"
#include <netconf_def.h>
#include <daemoni.h>
#include <netconf.pe>
#include "m4mailconf.m"
#include <dialog.h>
#include <usercomng.h>

M4MAILCONF_HELP_FILE help_m4mailconf ("intro");
extern CONFIG_FILE f_sendmail_mc;

PUBLIC void M4MAILCONF::spcs_edit()
{
	if (spcs.edit() == 0){
		spcs.build();
	}
}

void m4mailconf_edit()
{
	/* #Specification: m4mailconf / main menu
	*/
	int choice=0;
	int modified = 0;
	static const char *basic = MSG_U(M_BASIC,"basic information");
	static const char *spc_route = MSG_U(M_SPECIAL,"special (domain) routing");
	static const char *cplx_route = MSG_U(M_COMPLEX,"complex (user) routing");
	static const char *masq_rule = MSG_U(M_MASQ,"masquerading rules");
	static const char *mailfax = MSG_U(M_FAX,"mail to fax gateway");
	static const char *virt_domain = MSG_U(M_VIRTDOM,"virtual email domain");
	static const char *ualias = MSG_U(M_ALIASES,"user aliases");
	static const char *vualias = MSG_U(M_VALIASES,"virtual domain user aliases");
	static const char *spam_features = MSG_U(M_SFEAT,"Relay Features");
	static const char *spam_host_ctrl = MSG_U(M_SHOSTCTRL,"Per-host/domain access control");
	static const char *spam_user_ctrl = MSG_U(M_SUSERCTRL,"Per-user access control");
	static const char *spam_host_relay = MSG_U(M_SHOSTRELAY,"Per-host/domain relay control");

	static const char *mailq = MSG_U(M_MAILQ,"the mail queue");

	  //static const char *test_cases = MSG_U(M_TESTS,"test cases");
	  //static const char *test_run = MSG_R(M_TESTS);

	static const char *menuopt1[]={
		"-",		MSG_U(T_BASECONF,"Basic"),
		MSG_U(M_CONFIG,"Configure"),	basic,
		"",			spc_route,
		"",			cplx_route,
		"",			masq_rule,
		"",			mailfax,
		"",			virt_domain,
		MSG_U(M_MANAGE,"Manage"),mailq,
		MSG_U(M_SETTING,"Setting"),	ualias,
		"",			vualias,
		NULL
	};
	static const char *menuopt2[]={
	  "-", MSG_U(T_SPAMRULES, "Anti-spam filters"),
	  MSG_R(M_CONFIG), spam_features,
	  MSG_R(M_SETTING), spam_host_ctrl, // Hosts/Domains in access.db
	  "", spam_user_ctrl,               // Users in access.db
	  "", spam_host_relay,              // Hosts/Domains in relay-domains
	  NULL
	};
	
	DIALOG_MENU dia;
	dia.new_menuitems (menuopt1);
	dia.setmenu (MENU_MAILCONF);
	SSTRING sendpath (f_sendmail_mc.getpath());
	dia.new_menuitem  (MSG_U(M_GENERATE,"Generate"),sendpath.get());
	dia.new_menuitems (menuopt2);
	while (1){
		MENU_STATUS code = dia.editmenu (
			MSG_U(T_SENDMAIL,"Sendmail configurator")
			,MSG_U(I_SENDMAIL
			 ,"This package allows you to configure\n"
			  "Sendmail, the mail delivery system\n")
			,help_m4mailconf
			,choice,0);
		if (code == MENU_QUIT || code == MENU_ESCAPE){
			if (modified){
				char buf[100];
				sprintf (buf,MSG_U(Q_GENSENDMAIL,"Generating %s"),sendpath.get());
				char intro[1000];
				sprintf (intro
					,MSG_U(I_GENSENDMAIL
						,"You have modified sendmail's configuration.\n"
						 "A new %s must be generated.\n"
						 "Do you want to do it now")
					,sendpath.get());
				if (xconf_yesno(buf,intro,help_m4mailconf) == MENU_YES){
					M4MAILCONF mconf;
					mconf.generate();
				}
			}
			break;
		}else{
			const char *key = dia.getmenustr (choice);
			M4MAILCONF mconf;
			if (key == basic){
				modified |= mconf.basicedit();
			}else if (key == virt_domain){
				VDOMAINS vdomains;
				modified |= vdomains.edit();
			}else if (key == spc_route){
				mconf.spcs_edit();
			}else if (key == cplx_route){
				modified |= complex_edit();
			}else if (key == masq_rule){
				modified |= masq_edit();
			}else if (key == mailfax){
				modified |= mailfax_edit();
			}else if (key == mailq){
				mailq_edit();
			}else if (key == ualias){
				aliases_edit();
			}else if (key == vualias){
				vdomain_editaliases();

				// ANTISPAM
			}else if (key == spam_features){
				modified = mconf.spam_edit_spam_features();
				/*			}else if (key == spam_host_ctrl){
							spam_edit_host_ctrl();
							}else if (key == spam_user_ctrl){
							spam_edit_user_ctrl();
							}else if (key == spam_host_relay){
							spam_edit_host_relay(); */

			}else if (key == sendpath.get()){
				if (dialog_mode != DIALOG_TREE){
					mconf.generate();
					modified = 0;
				}
			}
		}
	}
}

/*
	Return the queue processing delay in minutes.
	Used to call sendmail (option -q)
*/
int m4mailconf_getqueuedelay()
{
	M4MAILCONF mconf;
	return mconf.getqueuedelay();
}


int m4mailconf_mainmenu()
{
	if (netconf_mainaccess()){
		while (1){
			m4mailconf_edit();
			if (netconf_checkupdate(true)!=2) break;
		}
	}
	return 0;
}

/*
	Generated sendmail.mc if needed
	Return 1 if the sendmail.mc was generated
*/
int m4mailconf_generate_if()
{
	int ret = 0;
	if (m4mailconf_generated_once()){
		mtable_makemap(f_mailtable);
		mtable_makemap(f_spam_deny);
		mtable_makemap(f_virtuser);
		mtable_makemap(f_pophash);
		M4MAILCONF mconf;
		ret = mconf.generate_if();
	}
	return ret;
}

// We declare this here to make sure aliascomng.o is linked in

static REGISTER_USERACCT_COMNG ppp (alias_newcomng);
static REGISTER_USERACCT_COMNG xxx (vdomain_newcomng);

